#lang racket

(define names
  '("Johnny" "christine" "FRANK" "Juliette" "JOANNA" "eugene"))

;; (map string-downcase names)
;; 
;; (filter (lambda (s)
;;           (string-prefix? s "j"))
;;         (map string-downcase names))
;; 
;; (map string-length
;;      (filter (lambda (s)
;;                (string-prefix? s "j"))
;;              (map string-downcase names)))
;; 
;; (apply + (map string-length
;;               (filter (lambda (s)
;;                         (string-prefix? s "j"))
;;                       (map string-downcase names))))

(define total-starting-with
  (lambda (char list-of-strings)
    (apply +
           (map string-length
                (filter (lambda (s)
                          (string-prefix? s char))
                        (map string-downcase list-of-strings))))))

;; > (total-starting-with "j" names)
;; 20
;; > (total-starting-with "e" names)
;; 6
;; > (total-starting-with "a" names)
;; 0
